    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------
    028     * XYAnnotationEntity.java
    029     * -----------------------
    030     * (C) Copyright 2004-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 29-Sep-2004 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.chart.entity;
    042
    043    import java.awt.Shape;
    044    import java.io.Serializable;
    045
    046    /**
    047     * A chart entity that represents an annotation on an
    048     * {@link org.jfree.chart.plot.XYPlot}.
    049     */
    050    public class XYAnnotationEntity extends ChartEntity
    051                                    implements Serializable {
    052
    053        /** For serialization. */
    054        private static final long serialVersionUID = 2340334068383660799L;
    055
    056        /** The renderer index. */
    057        private int rendererIndex;
    058
    059        /**
    060         * Creates a new entity.
    061         *
    062         * @param hotspot  the area.
    063         * @param rendererIndex  the rendererIndex (zero-based index).
    064         * @param toolTipText  the tool tip text.
    065         * @param urlText  the URL text for HTML image maps.
    066         */
    067        public XYAnnotationEntity(Shape hotspot, int rendererIndex,
    068                                  String toolTipText, String urlText) {
    069            super(hotspot, toolTipText, urlText);
    070            this.rendererIndex = rendererIndex;
    071        }
    072
    073        /**
    074         * Returns the renderer index.
    075         *
    076         * @return The renderer index.
    077         */
    078        public int getRendererIndex() {
    079            return this.rendererIndex;
    080        }
    081
    082        /**
    083         * Sets the renderer index.
    084         *
    085         * @param index  the item index (zero-based).
    086         */
    087        public void setRendererIndex(int index) {
    088            this.rendererIndex = index;
    089        }
    090
    091        /**
    092         * Tests the entity for equality with an arbitrary object.
    093         *
    094         * @param obj  the object (<code>null</code> permitted).
    095         *
    096         * @return A boolean.
    097         */
    098        public boolean equals(Object obj) {
    099            if (obj == this) {
    100                return true;
    101            }
    102            if (!super.equals(obj)) {
    103                return false;
    104            }
    105            if (!(obj instanceof XYAnnotationEntity)) {
    106                return false;
    107            }
    108            XYAnnotationEntity that = (XYAnnotationEntity) obj;
    109            if (this.rendererIndex != that.rendererIndex) {
    110                return false;
    111            }
    112            return true;
    113        }
    114
    115    }